"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var assert = require("assert");
var ts = require("typescript");
/**
 * Code generator for the break statement
 */
var BreakStatementCodeGenerator = (function () {
    function BreakStatementCodeGenerator() {
        this.syntaxKind = ts.SyntaxKind.BreakStatement;
    }
    BreakStatementCodeGenerator.prototype.generate = function (breakStatement, context) {
        var target;
        if (breakStatement.label) {
            target = context.scope.getBreakBlock(breakStatement.label.text);
        }
        else {
            target = context.scope.getBreakBlock();
        }
        assert(target, "Break block for label '" + (breakStatement.label ? breakStatement.label.text : "") + "' is missing");
        context.builder.createBr(target);
    };
    return BreakStatementCodeGenerator;
}());
exports.default = BreakStatementCodeGenerator;
//# sourceMappingURL=break-statement-code-generator.js.map