"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var assert = require("assert");
var ts = require("typescript");
/**
 * Code generator for the continue statement
 */
var ContinueStatementCodeGenerator = (function () {
    function ContinueStatementCodeGenerator() {
        this.syntaxKind = ts.SyntaxKind.ContinueStatement;
    }
    ContinueStatementCodeGenerator.prototype.generate = function (node, context) {
        var target;
        if (node.label) {
            target = context.scope.getContinueBlock(node.label.text);
        }
        else {
            target = context.scope.getContinueBlock();
        }
        assert(target, "Continue block for label '" + (node.label ? node.label.text : "") + "' is missing");
        context.builder.createBr(target);
    };
    return ContinueStatementCodeGenerator;
}());
exports.default = ContinueStatementCodeGenerator;
//# sourceMappingURL=continue-statement-code-generator.js.map