"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var llvm = require("llvm-node");
var ts = require("typescript");
var primitive_1 = require("../value/primitive");
var FalseKeywordCodeGenerator = (function () {
    function FalseKeywordCodeGenerator() {
        this.syntaxKind = ts.SyntaxKind.FalseKeyword;
    }
    FalseKeywordCodeGenerator.prototype.generate = function (node, context) {
        var value = llvm.ConstantInt.getFalse(context.llvmContext);
        return new primitive_1.Primitive(value, context.typeChecker.getTypeAtLocation(node));
    };
    return FalseKeywordCodeGenerator;
}());
exports.default = FalseKeywordCodeGenerator;
//# sourceMappingURL=false-keyword-code-generator.js.map