"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var unresolved_function_reference_1 = require("../value/unresolved-function-reference");
/**
 * Code Generator for a function declaration
 */
var FunctionDeclarationCodeGenerator = (function () {
    function FunctionDeclarationCodeGenerator() {
        this.syntaxKind = ts.SyntaxKind.FunctionDeclaration;
    }
    FunctionDeclarationCodeGenerator.prototype.generate = function (functionDeclaration, context) {
        var symbol = context.typeChecker.getSymbolAtLocation(functionDeclaration.name);
        var type = context.typeChecker.getTypeAtLocation(functionDeclaration);
        var apparentType = context.typeChecker.getApparentType(type);
        var callSignatures = context.typeChecker.getSignaturesOfType(apparentType, ts.SignatureKind.Call);
        var functionReference = unresolved_function_reference_1.UnresolvedFunctionReference.createFunction(callSignatures, context);
        context.scope.addFunction(symbol, functionReference);
    };
    return FunctionDeclarationCodeGenerator;
}());
exports.default = FunctionDeclarationCodeGenerator;
//# sourceMappingURL=function-declaration-code-generator.js.map