"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var code_generation_diagnostic_1 = require("../../code-generation-diagnostic");
var class_reference_1 = require("../value/class-reference");
var PropertyAccessExpressionCodeGenerator = (function () {
    function PropertyAccessExpressionCodeGenerator() {
        this.syntaxKind = ts.SyntaxKind.PropertyAccessExpression;
    }
    PropertyAccessExpressionCodeGenerator.prototype.generate = function (propertyExpression, context) {
        var object = context.generateValue(propertyExpression.expression).dereference(context);
        if (object.isObject()) {
            return object.getProperty(propertyExpression, context);
        }
        if (object instanceof class_reference_1.ClassReference) {
            throw code_generation_diagnostic_1.CodeGenerationDiagnostic.unsupportedStaticProperties(propertyExpression);
        }
        // e.g. on function
        throw code_generation_diagnostic_1.CodeGenerationDiagnostic.unsupportedProperty(propertyExpression);
    };
    return PropertyAccessExpressionCodeGenerator;
}());
exports.default = PropertyAccessExpressionCodeGenerator;
//# sourceMappingURL=property-access-expression-code-generator.js.map