"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var llvm = require("llvm-node");
var ts = require("typescript");
var primitive_1 = require("../value/primitive");
var TrueKeywordCodeGenerator = (function () {
    function TrueKeywordCodeGenerator() {
        this.syntaxKind = ts.SyntaxKind.TrueKeyword;
    }
    TrueKeywordCodeGenerator.prototype.generate = function (node, context) {
        var trueValue = llvm.ConstantInt.getTrue(context.llvmContext);
        return new primitive_1.Primitive(trueValue, context.typeChecker.getTypeAtLocation(node));
    };
    return TrueKeywordCodeGenerator;
}());
exports.default = TrueKeywordCodeGenerator;
//# sourceMappingURL=true-keyword-code-generator.js.map