"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
var code_generation_diagnostic_1 = require("../../code-generation-diagnostic");
var VariableDeclarationListCodeGenerator = (function () {
    function VariableDeclarationListCodeGenerator() {
        this.syntaxKind = ts.SyntaxKind.VariableDeclarationList;
    }
    VariableDeclarationListCodeGenerator.prototype.generate = function (variableDeclarationList, context) {
        if ((variableDeclarationList.flags & ts.NodeFlags.Let) !== ts.NodeFlags.Let &&
            (variableDeclarationList.flags & ts.NodeFlags.Const) !== ts.NodeFlags.Const) {
            throw code_generation_diagnostic_1.CodeGenerationDiagnostic.variableDeclarationList(variableDeclarationList);
        }
        context.generateChildren(variableDeclarationList);
    };
    return VariableDeclarationListCodeGenerator;
}());
exports.default = VariableDeclarationListCodeGenerator;
//# sourceMappingURL=variable-declaration-list-code-generator.js.map