"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var base_name_mangler_1 = require("./base-name-mangler");
/**
 * C++ inspired name mangler.
 *
 * Functions are postfixed with the encoded types of their arguments. The type codes are
 * boolean:     b
 * int:         i
 * number:      d
 * Object:      Pv (Pointer void)
 *
 * Function and type names are prefixed with their length to avoid conflicts.
 */
var DefaultNameMangler = (function (_super) {
    __extends(DefaultNameMangler, _super);
    function DefaultNameMangler() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(DefaultNameMangler.prototype, "separator", {
        get: function () {
            return "$";
        },
        enumerable: true,
        configurable: true
    });
    DefaultNameMangler.prototype.encodeName = function (name) {
        return "" + name.length + name;
    };
    DefaultNameMangler.prototype.getModulePrefix = function (sourceFile) {
        if (sourceFile) {
            var relativePath = path.relative(this.compilationContext.rootDir, sourceFile.fileName);
            var normalized = path.normalize(relativePath);
            return normalized.replace(/$/g, "$$").replace(/_/g, "__").replace(/-/g, "_");
        }
        return "";
    };
    return DefaultNameMangler;
}(base_name_mangler_1.BaseNameMangler));
exports.DefaultNameMangler = DefaultNameMangler;
//# sourceMappingURL=default-name-mangler.js.map