"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * If the compiler is set to emit llvm code instead of WASM files, than the source files should not be rewritten
 */
var NoopSourceFileRewriter = (function () {
    function NoopSourceFileRewriter() {
    }
    NoopSourceFileRewriter.prototype.setWastMetaData = function (metadata) {
        // noop
    };
    NoopSourceFileRewriter.prototype.setWasmUrl = function (wasmUrl) {
        // noop
    };
    NoopSourceFileRewriter.prototype.rewriteEntryFunction = function (name, functionDeclaration) {
        return functionDeclaration;
    };
    NoopSourceFileRewriter.prototype.rewriteSourceFile = function (sourceFile, requestEmitHelper) {
        return sourceFile;
    };
    return NoopSourceFileRewriter;
}());
exports.NoopSourceFileRewriter = NoopSourceFileRewriter;
//# sourceMappingURL=llvm-emit-source-file-rewriter.js.map