"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
/**
 * Returns the type of the object to which the given node belongs to or undefined
 * @param node the node for which its belonging object (e.g. x for x.y) should be returned
 * @param typeChecker the type checker
 * @returns the type of the object node or undefined
 */
function getTypeOfParentObject(node, typeChecker) {
    if (node.kind === ts.SyntaxKind.PropertyAccessExpression || node.kind === ts.SyntaxKind.ElementAccessExpression) {
        var accessExpression = node;
        return typeChecker.getTypeAtLocation(accessExpression.expression);
    }
    return undefined;
}
exports.getTypeOfParentObject = getTypeOfParentObject;
//# sourceMappingURL=object-helper.js.map