"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var debug = require("debug");
var tools_1 = require("./tools");
var LOG = debug("external-tools/binaryen-opt");
var EXECUTABLE_NAME = "wasm-opt";
/**
 * Optimizes the given wast file
 * @param wastFile the wast file to optimize
 * @param outputFile the name of the resulting wast file the optimization level
 * @return the path to the optimized .wast file. The caller is responsible for either deleting the working directory or the returned
 * file.
 */
function wasmOpt(wastFile, outputFile) {
    LOG("Optimize " + wastFile);
    LOG(tools_1.execBinaryen(EXECUTABLE_NAME, "\"" + wastFile + "\" -o \"" + outputFile + "\" --post-emscripten --emit-text"));
    return outputFile;
}
exports.wasmOpt = wasmOpt;
//# sourceMappingURL=binaryen-opt.js.map