"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var debug = require("debug");
var speedyjs_runtime_1 = require("speedyjs-runtime");
var tools_1 = require("./tools");
var LOG = debug("external-tools/binaryen-s2wasm");
var EXECUTABLE_NAME = "s2wasm";
/**
 * Creates the .wast file from the given s file
 * @param sFile the s file
 * @param wastFile the name of the wast file
 * @param options options passed to s2wasm that affect the generated module
 * @return the path to the .wast file. The caller is responsible for either deleting the working directory or the returned
 * file.
 */
function s2wasm(sFile, wastFile, _a) {
    var globalBase = _a.globalBase, initialMemory = _a.initialMemory;
    LOG("Compile " + sFile + " to wast file");
    var args = "\"" + sFile + "\" -o \"" + wastFile + "\" -l \"" + speedyjs_runtime_1.COMPILER_RT_FILE + "\" --emscripten-glue --global-base=" + globalBase + " --initial-memory=" + initialMemory;
    LOG(tools_1.execBinaryen(EXECUTABLE_NAME, args));
    return wastFile;
}
exports.s2wasm = s2wasm;
//# sourceMappingURL=binaryen-s2wasm.js.map