"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var debug = require("debug");
var tools_1 = require("./tools");
var LOG = debug("external-tools/binaryen-wasm-as");
var EXECUTABLE_NAME = "wasm-as";
/**
 * Compiles the given wast file to a wasm file
 * @param wast the wast file to compile
 * @param outputFile the file name of the generated wasm file
 */
function wasmAs(wast, outputFile) {
    LOG("Compile wast " + wast + " to wasm " + outputFile);
    LOG(tools_1.execBinaryen(EXECUTABLE_NAME, "\"" + wast + "\" -o \"" + outputFile + "\""));
}
exports.wasmAs = wasmAs;
//# sourceMappingURL=binaryen-wasm-as.js.map