"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var debug = require("debug");
var tools_1 = require("./tools");
var LOG = debug("external-tools/llvm-llc");
var EXECUTABLE_NAME = "llc";
// tslint:disable-next-line:max-line-length
var DEFAULT_OPTIONS = "-march=wasm32 -filetype=asm -asm-verbose=false -thread-model=single -combiner-global-alias-analysis=false -enable-emscripten-cxx-exceptions -enable-emscripten-sjlj";
/**
 * Generates the static assembly using llc
 * @param input the input file name (absolute)
 * @param sFileName the name of the resulting s file
 * @returns the name of the generated assembly file. The caller is responsible for deleting either the working directory
 * or the assembly file
 */
function llc(input, sFileName) {
    LOG("Execute LLC for file " + input);
    LOG(tools_1.execLLVM(EXECUTABLE_NAME, DEFAULT_OPTIONS + " \"" + input + "\" -o \"" + sFileName + "\""));
    return sFileName;
}
exports.llc = llc;
//# sourceMappingURL=llvm-llc.js.map