"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var debug = require("debug");
var ts = require("typescript");
var LOG = debug("transform/LogUnknownTransformVisitor");
/**
 * Logs yet unknown ts.Nodes
 */
var LogUnknownTransformVisitor = (function () {
    function LogUnknownTransformVisitor() {
    }
    LogUnknownTransformVisitor.prototype.visitSourceFile = function (sourceFile, context) {
        return context.visitEachChild(sourceFile);
    };
    LogUnknownTransformVisitor.prototype.visitFunctionDeclaration = function (functionDeclaration, context) {
        return context.visitEachChild(functionDeclaration);
    };
    LogUnknownTransformVisitor.prototype.visitExportKeyword = function (exportKeyword, context) {
        return context.visitEachChild(exportKeyword);
    };
    LogUnknownTransformVisitor.prototype.visitIdentifier = function (identifier, context) {
        return context.visitEachChild(identifier);
    };
    LogUnknownTransformVisitor.prototype.visitParameter = function (parameter, context) {
        return context.visitEachChild(parameter);
    };
    LogUnknownTransformVisitor.prototype.visitNumberKeyword = function (keyword, context) {
        return context.visitEachChild(keyword);
    };
    LogUnknownTransformVisitor.prototype.visitBlock = function (block, context) {
        return context.visitEachChild(block);
    };
    LogUnknownTransformVisitor.prototype.visitExpressionStatement = function (expressionStatement, context) {
        return context.visitEachChild(expressionStatement);
    };
    LogUnknownTransformVisitor.prototype.visitStringLiteral = function (stringLiteral, context) {
        return context.visitEachChild(stringLiteral);
    };
    LogUnknownTransformVisitor.prototype.visitIfStatement = function (ifStatement, context) {
        return context.visitEachChild(ifStatement);
    };
    LogUnknownTransformVisitor.prototype.visitBinaryExpression = function (binaryExpression, context) {
        return context.visitEachChild(binaryExpression);
    };
    LogUnknownTransformVisitor.prototype.visitFirstLiteralToken = function (firstLiteralToken, context) {
        return context.visitEachChild(firstLiteralToken);
    };
    LogUnknownTransformVisitor.prototype.visitReturnStatement = function (returnStatement, context) {
        return context.visitEachChild(returnStatement);
    };
    LogUnknownTransformVisitor.prototype.visitCallExpression = function (callExpression, context) {
        return context.visitEachChild(callExpression);
    };
    LogUnknownTransformVisitor.prototype.visitAsyncKeyword = function (asyncKeyword, context) {
        return context.visitEachChild(asyncKeyword);
    };
    LogUnknownTransformVisitor.prototype.visitIntKeyword = function (intKeyword, context) {
        return context.visitEachChild(intKeyword);
    };
    LogUnknownTransformVisitor.prototype.visitTypeReference = function (typeReference, context) {
        return context.visitEachChild(typeReference);
    };
    LogUnknownTransformVisitor.prototype.visitAwaitExpression = function (awaitExpression, context) {
        return context.visitEachChild(awaitExpression);
    };
    LogUnknownTransformVisitor.prototype.visitVariableDeclaration = function (variableDeclaration, context) {
        return context.visitEachChild(variableDeclaration);
    };
    LogUnknownTransformVisitor.prototype.visitVariableDeclarationList = function (variableDeclarationList, context) {
        return context.visitEachChild(variableDeclarationList);
    };
    LogUnknownTransformVisitor.prototype.visitVariableStatement = function (variableStatement, context) {
        return context.visitEachChild(variableStatement);
    };
    LogUnknownTransformVisitor.prototype.visitNewExpression = function (newExpression, context) {
        return context.visitEachChild(newExpression);
    };
    LogUnknownTransformVisitor.prototype.visitBooleanKeyword = function (booleanKeyword, context) {
        return context.visitEachChild(booleanKeyword);
    };
    LogUnknownTransformVisitor.prototype.visitPropertyAccessExpression = function (propertyAccessExpression, context) {
        return context.visitEachChild(propertyAccessExpression);
    };
    LogUnknownTransformVisitor.prototype.visitTrueKeyword = function (trueKeyword, context) {
        return context.visitEachChild(trueKeyword);
    };
    LogUnknownTransformVisitor.prototype.visitForStatement = function (forStatement, context) {
        return context.visitEachChild(forStatement);
    };
    LogUnknownTransformVisitor.prototype.visitPrefixUnaryExpression = function (prefixUnaryExpression, context) {
        return context.visitEachChild(prefixUnaryExpression);
    };
    LogUnknownTransformVisitor.prototype.visitElementAccessExpression = function (elementAccessExpression, context) {
        return context.visitEachChild(elementAccessExpression);
    };
    LogUnknownTransformVisitor.prototype.visitFalseKeyword = function (falseKeyword, context) {
        return context.visitEachChild(falseKeyword);
    };
    LogUnknownTransformVisitor.prototype.visitParenthesizedExpression = function (parenthesizedExpression, context) {
        return context.visitEachChild(parenthesizedExpression);
    };
    LogUnknownTransformVisitor.prototype.visitThisKeyword = function (thisKeyword, context) {
        return context.visitEachChild(thisKeyword);
    };
    LogUnknownTransformVisitor.prototype.visitPropertyDeclaration = function (propertyDeclaration, context) {
        return context.visitEachChild(propertyDeclaration);
    };
    LogUnknownTransformVisitor.prototype.visitPrivateKeyword = function (privateKeyword, context) {
        return context.visitEachChild(privateKeyword);
    };
    LogUnknownTransformVisitor.prototype.visitConstructor = function (constructor, context) {
        return context.visitEachChild(constructor);
    };
    LogUnknownTransformVisitor.prototype.visitArrayLiteralExpression = function (arrayLiteralExpression, context) {
        return context.visitEachChild(arrayLiteralExpression);
    };
    LogUnknownTransformVisitor.prototype.visitClassDeclaration = function (classDeclaration, context) {
        return context.visitEachChild(classDeclaration);
    };
    LogUnknownTransformVisitor.prototype.visitMethodDeclaration = function (methodDeclaration, context) {
        return context.visitEachChild(methodDeclaration);
    };
    LogUnknownTransformVisitor.prototype.visitWhileStatement = function (whileStatement, context) {
        return context.visitEachChild(whileStatement);
    };
    LogUnknownTransformVisitor.prototype.visitBreakStatement = function (breakStatement, context) {
        return context.visitEachChild(breakStatement);
    };
    LogUnknownTransformVisitor.prototype.visitPublicKeyword = function (publicKeyword, context) {
        return context.visitEachChild(publicKeyword);
    };
    LogUnknownTransformVisitor.prototype.visitArrayType = function (arrayType, context) {
        return context.visitEachChild(arrayType);
    };
    LogUnknownTransformVisitor.prototype.visitAsExpression = function (asExpression, context) {
        return context.visitEachChild(asExpression);
    };
    LogUnknownTransformVisitor.prototype.visitConditionalExpression = function (conditionalExpression, context) {
        return context.visitEachChild(conditionalExpression);
    };
    LogUnknownTransformVisitor.prototype.visitContinueStatement = function (continueStatement, context) {
        return context.visitEachChild(continueStatement);
    };
    LogUnknownTransformVisitor.prototype.fallback = function (node, context) {
        LOG("Unknown Node Type " + ts.SyntaxKind[node.kind] + " - " + node.constructor.name);
        return context.visitEachChild(node);
    };
    return LogUnknownTransformVisitor;
}());
exports.LogUnknownTransformVisitor = LogUnknownTransformVisitor;
//# sourceMappingURL=log-unknown-transform-visitor.js.map