"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ts = require("typescript");
/** Mostly copied from TypeScript Source as it is not exposed */
function createGetCanonicalFileName(useCaseSensitiveFileNames) {
    return useCaseSensitiveFileNames
        ? function (fileName) { return fileName; }
        : function (fileName) { return fileName.toLowerCase(); };
}
var defaultFormatDiagnosticHost = {
    getCurrentDirectory: function () {
        return ts.sys.getCurrentDirectory();
    },
    getNewLine: function () {
        return ts.sys.newLine;
    },
    getCanonicalFileName: createGetCanonicalFileName(ts.sys.useCaseSensitiveFileNames)
};
/**
 * Prints the given diagnostic messages to the console
 * @param diagnostics the diagnostics to report
 * @param compilerHost the compiler host
 */
function reportDiagnostics(diagnostics, compilerHost) {
    for (var _i = 0, diagnostics_1 = diagnostics; _i < diagnostics_1.length; _i++) {
        var diagnostic = diagnostics_1[_i];
        ts.sys.write(formatDiagnostics([diagnostic], compilerHost));
    }
}
exports.reportDiagnostics = reportDiagnostics;
/**
 * Formats the given diagnostics as a string
 * @param diagnostics the diagnostics to format
 * @param compilerHost the compiler hsot
 * @return {string} the diagnostics as string
 */
function formatDiagnostics(diagnostics, compilerHost) {
    return ts.formatDiagnostics(diagnostics, compilerHost || defaultFormatDiagnosticHost);
}
exports.formatDiagnostics = formatDiagnostics;
//# sourceMappingURL=diagnostics.js.map